package com.chinaitop.depot.monitor.controller;

import java.util.HashMap;
import java.util.Map;

import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSON;
import com.chinaitop.depot.monitor.model.ControllingRequest;
import com.hikvision.artemis.sdk.ArtemisHttpUtil;
import com.hikvision.artemis.sdk.config.ArtemisConfig;


/**
 * 云台控制类
 * @author hf
 *
 */
@RestController
@RequestMapping(value="/ptzControl")
public class PtzController {
	/**
	 * 请根据自己的appKey和appSecret更换static静态块中的三个参数。
	 */
	static {
		ArtemisConfig.host = "106.3.145.75:443"; // artemis网关服务器ip端口
		ArtemisConfig.appKey = "26469219"; // 秘钥appkey   28116466
		ArtemisConfig.appSecret = "w4GKdMLvVTxDLUgtzV2L";// 秘钥appSecret   W9zihM0hNRsnNic3zuKM
	}
	/**
	 * 能力开放平台的网站路径
	 * 路径不用修改，就是/artemis
	 */
	private static final String ARTEMIS_PATH = "/artemis";

	/**
	 * 根据监控点编号进行云台操作
	 * @param cameraIndexCode	监控点编号
	 * @return
	 */
	@RequestMapping(value="/usePTZ", method = RequestMethod.GET)
	public String usePTZ(String ctrl,Integer type,String cameraIndexCode) {
		ControllingRequest request=new ControllingRequest();
        request.setCameraIndexCode(cameraIndexCode);//监控点编号
        request.setAction(type);//0-开始  1-停止
        /*LEFT左转  RIGHT右转  UP上转  DOWN下转  ZOOM_IN焦距变大  ZOOM_OUT焦距变小  LEFT_UP左上
        LEFT_DOWN左下  RIGHT_UP右上 RIGHT_DOWN右下 FOCUS_NEAR焦点前移  FOCUS_FAR焦点后移  IRIS_ENLARGE光圈扩大 IRIS_REDUCE光圈缩小；
                    以下命令presetIndex不可为空： GOTO_PRESET到预置点*/
        if(ctrl.equals("10001")) {//聚焦 +
        	request.setCommand("FOCUS_NEAR");
        }else if(ctrl.equals("10002")) {//聚焦 -
        	request.setCommand("FOCUS_FAR");
        }else if(ctrl.equals("10003")) {//调焦 +
        	request.setCommand("ZOOM_IN");
        }else if(ctrl.equals("10004")) {//调焦 -
        	request.setCommand("ZOOM_OUT");
        }
        request.setSpeed(10);//云台速度
        //request.setPresetIndex(20);//预置点编号

		String controllingDataApi = ARTEMIS_PATH +"/api/video/v1/ptzs/controlling";
		Map<String,String> path = new HashMap<String,String>(2){
			{
				put("https://",controllingDataApi);
			}
		};
		String body=JSON.toJSONString(request);
		String result =ArtemisHttpUtil.doPostStringArtemis(path,body,null,null,"application/json");
		return result;
	}

}
